import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class Runge extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public Runge()
   {  setSize(600,600);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double g(double X, double Y)
   {  return (X + 1) * Y; // ς炱ύX
   }
   private double f(double X)
   {  return Math.exp(X * X / 2 + X);
   }
   public double[] RungeKutta(double Y0,double XST,double DX,int N)
   { double[]Y = new double[N]; double X; int i;
     for(Y[0] = Y0, X = XST, i = 1; i < N; i++, X += DX)
     {  double K1 = g(X, Y[i - 1]);
        double K2 = g(X + DX / 2, Y[i - 1] + DX * K1 / 2);
        double K3 = g(X + DX / 2, Y[i - 1] + DX * K2 / 2);
        double K4 = g(X + DX, Y[i - 1] + DX * K3);
        Y[i] = Y[i - 1] + (K1 + 2 * K2 + 2 * K3 + K4) * DX / 6;
     }
     return Y;
   }
   public double[] RungeKuttaGill(double Y0,double XST,double DX,int N)
   { double[]Y = new double[N]; double X; int i; double S2=Math.sqrt(2);
     double A1 = 1 / 4 - 1 / (2*S2);  double A2 = 1/2 - 1 /(2* S2);
     double B1 = 1 / S2            ;  double B2 = 1 + 1 / S2;
     double C1 =  2 - 2 / S2       ;  double C2 = 2 + 2 / S2;
  
     for(Y[0] = Y0, X = XST, i = 1; i < N; i++, X += DX)
     {
       double K1 = g(X, Y[i - 1]);
       double K2 = g(X + DX / 2, Y[i - 1] + DX * K1 / 2                );
       double K3 = g(X + DX / 2, Y[i - 1] - A1 * DX * K1 + A2 * DX * K2);
       double K4 = g(X + DX    , Y[i - 1] - B1 * DX * K2 + B2 * DX * K3);
       Y[i] = Y[i - 1] + (K1 + C1 * K2 + C2 * K3 + K4) * DX / 6;
     }
     return Y;
   }
   public double[] Solution(double XST,double DX,int N)
   { double[]Y = new double[N]; double X; int i;
     for(X = XST, i = 0; i < N; i++, X += DX) Y[i] = f(X);
     return Y;
   }
   public int Xpos(double X)
   {  return (int)(X*200)+50;}
   public int Ypos(double Y)
   {  return 500- (int)(Y*5);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
 
   public void paint(Graphics g)
   {   g.setColor(new Color(  128, 128, 128));
      setTitle("QNb^@уQNb^M@");
      boolean Flag = false; double X, Y;
      for(X = 0; X <  2; X +=0.1) drawLine(g, X, 0, X, 70);
      for(Y = 0; Y <= 70; Y += 10) drawLine(g, 0, Y, 2,  Y);
      for(int i = 0; i <= 2; i++    )g.drawString("" + i, Xpos((double)i-0.01), Ypos(-3));
      for(int i = 0; i <=70; i += 10)g.drawString("" + i, Xpos(-0.1), Ypos((double)i-0.4));
      g.setColor(new Color(  0, 0, 0));
      drawLine(g, 0, 0, 0, 70); drawLine(g, 2,  0, 2, 70);
      drawLine(g, 0, 0, 2,  0); drawLine(g, 0, 70, 2, 70);
      g.drawString("FFRunge-Kutta@CԐFFRunge-Kutta-Gill@CFF^l",100,100);
      double Y0=1; double XST=0; double DX=0.01; int N=201; int i; double []Z;

      Z= Solution(XST, DX, N); g.setColor(new Color(  0,  0, 0)); Flag = false;
      for(X = XST, i = 0; i < N; i++, X += DX)
      {  Flag= Draw(g, X, Z[i], Flag); drawPoint(g, X,Z[i]);
      }

      Z= RungeKutta(Y0, XST, DX, N); g.setColor(new Color(  0,  0, 255)); Flag = false;
      for(X = XST, i = 0; i < N; i++, X += DX) Flag= Draw(g, X, Z[i], Flag); 
     
      Z= RungeKuttaGill(Y0, XST, DX, N); g.setColor(new Color( 255, 0, 0)); Flag = false;
      for(X = XST, i = 0; i < N; i++, X += DX) Flag= Draw(g, X, Z[i], Flag);
   } 
   public static void main(String[] args)
   {  Frame w = new Runge();
      w.setVisible(true);
   }
}
